//
// Classe DataMerger qui permet de regrouper les donnees
// apparaissant dans une fenetre en temps donnee
// Cette version fonctionne avec 1 parametre declencheur
// et des parametres esclaves
//

#ifndef DataMerger_h
#define DataMerger_h

#include "TObject.h"
#include "FParam.h"
#include <vector>

class DataMerger : public TNamed
{
 private:
    Double_t tsMin;
    Int_t    itMin;
    Int_t    nt;
    Int_t    ns;
    vector<Int_t> nbTrig;
    
 protected:
    virtual Bool_t CheckTrigger(void);
    virtual Bool_t CheckTriggerVectors(void);
    virtual Bool_t Decision(void);
    virtual void CountTriggersInWindow(void);
    virtual Double_t ComputeTriggerTime(void);
    virtual void MergeData(void);
    virtual void PrintValues(void);
    virtual void FindTSmin(void);
 
 
 protected:
    typedef vector<Double_t *> valTS;
    
    vector<FParam *> pTrigger;
    vector<FParam *> pTriggerTS;
    
    Double_t cDelay;
    Double_t cGate;

    Double_t dGate;
    
    Double_t chanToNs;
    Double_t tsMax;
    
    vector<FParam *> pSlave;
    vector<FParam *> pSlaveTS;
    
    vector<FParam *> vOutParam;
    
    vector<valTS *>  vPtrig;
    vector<valTS *>  vPslave;
    
 public:
     DataMerger(void);
     ~DataMerger(void);
     
     virtual void SetCollectionDelay(Double_t del) {cDelay=del;}
     virtual void SetCollectionGate(Double_t del) {cGate=del;}
     virtual Double_t GetCollectionDelay(void) {return cDelay;}
     virtual Double_t GetCollectionGate(void) {return cGate;}
     virtual void SetDecisionGate(Double_t del) {dGate=del;}
     virtual Double_t GetDecisionGate(void) {return dGate;}
     virtual void SetTSMax(Double_t del) {tsMax=del;}
     virtual Double_t GetTSMax(void) {return tsMax;}
     
     virtual void Reset(void);
     virtual void AddTriggerParam(FParam *px, FParam *TSx,
                                  FParam *&opx, FParam *&oTSx);
     virtual void AddSlaveParam(FParam *ps, FParam *TSs,
                                FParam *&ops, FParam *&oTSs);
     virtual vector<FParam *> GetOutParams(void)
      {return vOutParam;}
     virtual void Process(void); 
     virtual void ls(Option_t *option="") const;

//ClassDef(DataMerger,1)
};

#endif
