//
// Classe d'affichage des histogrammes pour la manip Fragmentation
//

#ifndef ManiFragPlotter_h
#define ManiFragPlotter_h

#include "TGFrame.h"
#include "TCanvas.h"
#include "TObjArray.h"
#include "TGTab.h"
#include "TGStatusBar.h"

class ManipFragPlotter : public TGMainFrame
{
 protected:
  TCanvas *canvasOsc;
  TCanvas *canvasHisto;
  TCanvas *canvasBidims;
  TCanvas *canvasCtrl;
  TCanvas *canvasTrig;
  TCanvas *canvasLibre;
  TGStatusBar *statusBar;
  TCanvas *currentCanvas;
  
  TObjArray curBout;
  Pixel_t   boutCol;
  TGTab     *fTab;
      
  enum 
   {
   padSaveAs,
   canvasSaveAs,
   padPrint,
   canvasPrint,
   quitRHB
   };
 
 public:
  ManipFragPlotter(const TGWindow *p=0,UInt_t w=800,UInt_t h=600);
  ~ManipFragPlotter();

  virtual void LoadOscillo(const Char_t *name=0);
  virtual void LoadHistos(const Char_t *name=0);
  virtual void LoadControles(const Char_t *name=0);
  virtual void LoadTelescopeMonos(const Char_t *name=0);
  virtual void LoadSiLiPlastMonos(const Char_t *name=0);
  virtual void LoadTelescopeBidims(const Char_t *name=0);
  virtual void LoadTelescopeTrigger(const Char_t *name=0);
  virtual void LoadControlesHistos(const Char_t *name=0);
  virtual void HandleFileMenu(Int_t menuItem);
  virtual void HighlightCurrentButton(void);
  virtual void TabSelected(Int_t i);
  virtual void DrawEventStatus(Int_t event, Int_t px, Int_t py, 
               TObject *selected=0);

ClassDef(ManipFragPlotter,1)
};

#endif
