//
// Patron pour la generation d'une classe derivee dans ROOT
// FH1F derive de TH1F
//

#ifndef FH1F_h
#define FH1F_h

#include "TH1F.h"
#include "FH1Att.h"

class FH1F : public TH1F, public FH1Att {

  protected:
    virtual void Init(void);       // initialisation

  public:
    FH1F(void);    // constructeur par defaut
    FH1F(const char* name, const char* title, Int_t nbinsx, Axis_t xlow, Axis_t xup);
    FH1F(const char* name, const char* title, Int_t nbinsx, const Float_t* xbins);
    FH1F(const char* name, const char* title, Int_t nbinsx, const Double_t* xbins);
    FH1F(const FH1F &ap); // constructeur par copie

    ~FH1F(void);		// desctructeur;

#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
    virtual void Copy(TObject & obj) const;
#else
    virtual void Copy(TObject & obj);
#endif
    FH1F& operator = (const FH1F &hp); // operateur =

    virtual TH1 *GetHisto(void);
    virtual void SavePrimitive(ostream &out, Option_t *opt="");

    ClassDef(FH1F,1)

};

#endif

