// 
// Patron pour la generation d'une classe derivee dans ROOT
// FIbisEventGenerator derive de FNetEventGenerator
// 
 
#ifndef FIbisEventGenerator_h 
#define FIbisEventGenerator_h 
 
//#include "FNetEventGenerator.h" 
#include "FIPEventGenerator.h" 
 
//class FIbisEventGenerator : public FNetEventGenerator { 
class FIbisEventGenerator : public FIPEventGenerator { 
 
   protected:
   	Bool_t	alreadyBuild[6];
	Int_t	nbData;
   
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FIbisEventGenerator(void);    // constructeur par defaut 
	FIbisEventGenerator(const FIbisEventGenerator &ap); // constructeur par copie 
	
	~FIbisEventGenerator(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FIbisEventGenerator& operator = (const FIbisEventGenerator &hp); // operateur = 

	virtual Int_t BuildNewEvent(UChar_t *EvtBuf);
	virtual Int_t BuildNewCard(UChar_t *EvtBuf);
	virtual Int_t BuildCardMS(UChar_t *EvtBuf);
	virtual Int_t BuildCardMI(UChar_t *EvtBuf);
	virtual Int_t BuildCardMX(UShort_t numCard, UChar_t *EvtBuf);
 
    ClassDef(FIbisEventGenerator,1)
 
}; 
 
#endif 
 
