// 
// Patron pour la generation d'une classe derivee dans ROOT
// FParam derive de TNamed
// 
 
#ifndef FParam_h 
#define FParam_h 
 
#include "Riostream.h" 
#include "TNamed.h" 
#include "TList.h" 
#include "TApplication.h" 

class FParam : public TNamed { 
 
   protected:
   	Bool_t	touche;
    	TList	*linkedObjects; //!
	Int_t	nbValues;
	Int_t	nbValuesMax;
	TString	valueType;
  
   protected: 
        virtual void Init(void);       // initialisation  

   public:	 
   	FParam(void);    // constructeur par defaut 
	FParam(const FParam &ap); // constructeur par copie 
	
	~FParam(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FParam& operator = (const FParam &hp); // operateur = 
 
 	virtual void    Reset(void){SetOff();}
 	virtual Double_t GetValue(Int_t i=0) const =0;
	virtual void    SetValue(Double_t val, Int_t i=0) =0;
	virtual Int_t	GetNbValues(void) const {return nbValues;}
        virtual void    SetNbValues(Int_t nbv){;}       // initialisation 
	virtual Int_t	GetNbValuesMax(void) const {return nbValuesMax;}
        virtual void    SetNbValuesMax(Int_t nbv){;}       // initialisation 
	virtual TString	GetValueType(void) const {return valueType;}
 	virtual void    WriteInFile(ofstream &fout)
	 {fout << ClassName() << ";" << GetName() << ";" << GetTitle() << endl;}
 	virtual Bool_t  ReadInFile(ifstream &fin, TList *lop){return fin.good();}
	virtual Bool_t 	IsOn(void) const {return touche;}
 	virtual void 	SetOn(void) {touche=kTRUE;}
 	virtual void 	SetOff(void) {touche=kFALSE;}
	virtual void 	Switch(void) {touche=!touche;}
	virtual TList *GetLinkedObjects(void){return linkedObjects;}
	
 	virtual void    ls(Option_t *option="") const;

	virtual void    Fatal(const char *method, const char *msgfmt, ...) const;

    ClassDef(FParam,1)
 
}; 
 
#endif 
 
