// 
// Patron pour la generation d'une classe derivee dans ROOT
// FParamBrutPersistant derive de FParamBrut
// 
 
#ifndef FParamBrutPersistant_h 
#define FParamBrutPersistant_h 
 
#include "FParamBrut.h" 
 
class FParamBrutPersistant : public FParamBrut { 
 
   protected: 
        Double_t valeur; // initialisation 

   protected: 
        virtual void Init(void); // initialisation 
 
   public:	 
   	FParamBrutPersistant(void); // constructeur par defaut 
	FParamBrutPersistant(const FParamBrutPersistant &ap); // constructeur par copie 
	
	~FParamBrutPersistant(void); // desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FParamBrutPersistant& operator = (const FParamBrutPersistant &hp); // operateur = 
 
	virtual void     Reset(){;} // On ne resette pas une valeur de reference en temps utilisee pour l'ecploitation d'un parametre calcule en temps !
	virtual void  	 SetValue(Double_t val,Int_t i=0){valeur=val; SetOn();}
 	virtual Double_t GetValue(Int_t i=0) const {return valeur;}
    ClassDef(FParamBrutPersistant,1)
}; 
#endif 
 
