//
// Canvas avec les reperes
//

#ifndef EmbeddedCanvasWithMark_h
#define EmbeddedCanvasWithMark_h

#include "MLineMark.h"
#include "TLatex.h"
#include "TLegend.h"
#include "TLegendEntry.h"
#include "TRootEmbeddedCanvas.h"

class MEmbeddedCanvasWithMarks: public TRootEmbeddedCanvas
{

 protected:
   TLatex ldx;
   TLatex ldy;
   MLineMark lmh1;
   MLineMark lmh2;
   MLineMark lmv1;
   MLineMark lmv2;
   
   Bool_t   mvOn;
   Bool_t   mhOn;
   
   TLegend       legend;
   TLegendEntry  leX1;
   TLegendEntry  leX2;
   TLegendEntry  leDX;
   TLegendEntry  leY1;
   TLegendEntry  leY2;
   TLegendEntry  leDY;
   
   virtual void Init(void);
   
 public:
   MEmbeddedCanvasWithMarks(const char* name = 0, const TGWindow* p = 0, 
                           UInt_t w = 10, UInt_t h = 10, 
			   UInt_t options = kSunkenFrame|kDoubleBorder, 
			   Pixel_t back = GetDefaultFrameBackground());
   ~MEmbeddedCanvasWithMarks(void);

   virtual void ActivateHorizontalMarks(void);
   virtual void ActivateVerticalMarks(void);
   virtual void DeactivateHorizontalMarks(void);
   virtual void DeactivateVerticalMarks(void);
   virtual void UpdateVisu(void);
   virtual void UpdateMarks(void);
   virtual Double_t GetX1(void) {return lmv1.GetX1();}
   virtual Double_t GetX2(void) {return lmv2.GetX1();}
   virtual Double_t GetY1(void) {return lmh1.GetX1();}
   virtual Double_t GetY2(void) {return lmh2.GetX1();}


ClassDef(MEmbeddedCanvasWithMarks,1)
};

#endif
