// 
// Patron pour la generation d'une classe derivee dans ROOT
// RHVOscillo derive de TGCompositeFrame
// 
 
#ifndef RHVOscillo_h 
#define RHVOscillo_h 
 
#include "TROOT.h"
#include "TGFrame.h"
#include "TCanvas.h"
#include "TGButton.h"
 
class RHVOscillo : public TGCompositeFrame { 

   protected: 
	TList	*listOfHistos;
	TCanvas	*canvasOscillo;
	TGCompositeFrame *cfOscBout;
	
	TGLayoutHints	*eX;
        TGButton *curBout;
        Pixel_t   boutCol;
	
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
	RHVOscillo(const TGWindow *p=0,UInt_t w=500,UInt_t h=300);
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	RHVOscillo(const RHVOscillo &ap); // constructeur par copie 
#endif
	
	~RHVOscillo(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	RHVOscillo& operator = (const RHVOscillo &hp); // operateur = 
 
	virtual Bool_t ProcessMessage(Long_t msg, Long_t par1, Long_t par2); 

	virtual TCanvas *GetCanvas(void) {return canvasOscillo;}
	virtual void SetListOfHistos(TList *l);
	virtual void BuildButtons(void);
	virtual void Reset(void);
	virtual void WarningBox(char const *title="Warning",char const *msg="Warning");
  	virtual void LoadOscillo(const Char_t *name=0);
  	virtual void HighlightCurrentButton(void);

    ClassDef(RHVOscillo,1)
 
}; 
 
#endif 
 
